'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = function (Lazyload, props) {
  var indexRoute = null;

  var LoadableComponent = Lazyload({
    component: function component() {
      return import('./routes/Pages');
    },
    LoadingComponent: _Loading2.default
  });

  // 路由加载Component
  if (props.routeData && props.routeData.length > 0) {
    props.routeData.map(function (item) {
      item.component = LoadableComponent;
      return item;
    });
  }
  // 首页路由
  // 获取自定义路由
  var indexProps = getIndexProps(props.menuSource) || {};
  if (indexProps) {
    props.routeData = props.routeData.filter(function (item) {
      return item.mdconf && item.mdconf.layout !== 'IndexLayout';
    });
  } else {
    // 未定义首页，默认第一个路由当首页
    indexProps = props.routeData.find(function (item, index) {
      return index === 0;
    });
    if (indexProps) indexProps.mdconf.layout = 'IndexLayout';
  }

  var indexItem = {
    path: '/',
    mdconf: (0, _extends3.default)({}, indexProps.mdconf, { layout: 'IndexLayout' }),
    props: (0, _extends3.default)({}, indexProps.props),
    article: indexProps.article
  };

  // 首页路由放置路由数组中生成路由
  props.routeData.unshift((0, _extends3.default)({}, indexItem, {
    component: LoadableComponent
  }));

  // 获取首页路由
  indexRoute = props.routeData.filter(function (item) {
    return item.mdconf && item.mdconf.layout === 'IndexLayout';
  });

  return _react2.default.createElement(
    _reactRouterDom.Switch,
    null,
    _react2.default.createElement(_reactRouterDom.Route, {
      path: '/404',
      render: function render(routeProps) {
        return _react2.default.createElement(
          _reactDocumentTitle2.default,
          { title: '404' },
          _react2.default.createElement(_NoMatch2.default, (0, _extends3.default)({}, routeProps, props))
        );
      }
    }),
    _react2.default.createElement(_reactRouterDom.Route, { path: '/',
      render: function render(routeProps) {
        var pathname = routeProps.location.pathname;

        routeProps.indexProps = indexItem;
        var curentRoute = props.routeData.filter(function (item) {
          return item.path === pathname;
        });
        var title = [];
        if (curentRoute.length > 0) {
          curentRoute = curentRoute[0];
          if (curentRoute.mdconf && curentRoute.mdconf.title && curentRoute.mdconf.layout !== 'IndexLayout') {
            title.push(curentRoute.mdconf.title);
          }
          if (indexItem.mdconf && indexItem.mdconf.title) {
            title.push(indexItem.mdconf.title);
          }
          title = title.length > 1 ? title.join(' - ') : title.join('');
        } else {
          title = '404';
        }
        return _react2.default.createElement(
          _reactDocumentTitle2.default,
          { title: title },
          pathname === '/' ? _react2.default.createElement(_IndexLayout2.default, (0, _extends3.default)({}, routeProps, props, { indexRoute: indexRoute })) : _react2.default.createElement(_BasicLayout2.default, (0, _extends3.default)({}, routeProps, props))
        );
      }
    })
  );
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _reactDocumentTitle = require('react-document-title');

var _reactDocumentTitle2 = _interopRequireDefault(_reactDocumentTitle);

var _BasicLayout = require('./layout/BasicLayout');

var _BasicLayout2 = _interopRequireDefault(_BasicLayout);

var _IndexLayout = require('./layout/IndexLayout');

var _IndexLayout2 = _interopRequireDefault(_IndexLayout);

var _NoMatch = require('./component/NoMatch');

var _NoMatch2 = _interopRequireDefault(_NoMatch);

var _Loading = require('./component/Loading');

var _Loading2 = _interopRequireDefault(_Loading);

require('./index.less');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 获取首页路由参数
// Markdown 配置 layout = 'IndexLayout'
var getIndexProps = function getIndexProps() {
  var menus = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var attr = arguments[1];

  menus.forEach(function (item) {
    if (item && item.mdconf && item.mdconf.layout === 'IndexLayout') {
      attr = item;
    }
    if (!attr && item.children && item.children.length > 0) {
      attr = getIndexProps(item.children, attr);
    }
  });
  return attr;
};