'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _BasicLayout = require('./BasicLayout.less');

var _BasicLayout2 = _interopRequireDefault(_BasicLayout);

var _Header = require('../component/Header');

var _Header2 = _interopRequireDefault(_Header);

var _Footer = require('../component/Footer');

var _Footer2 = _interopRequireDefault(_Footer);

var _rdocLogo = require('../rdoc.logo.svg');

var _rdocLogo2 = _interopRequireDefault(_rdocLogo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getCurrentArticle(routeData, path) {
  var article = null;
  routeData.forEach(function (item) {
    if (item.path === path) {
      article = item.article;
    }
  });
  return article;
}

var BasicLayout = function (_PureComponent) {
  (0, _inherits3.default)(BasicLayout, _PureComponent);

  function BasicLayout(props) {
    (0, _classCallCheck3.default)(this, BasicLayout);

    var _this = (0, _possibleConstructorReturn3.default)(this, (BasicLayout.__proto__ || (0, _getPrototypeOf2.default)(BasicLayout)).call(this, props));

    _this.state = {};
    return _this;
  }

  (0, _createClass3.default)(BasicLayout, [{
    key: 'renderSubMenuItem',
    value: function renderSubMenuItem(menus) {
      var _this2 = this;

      var pathname = this.props.location.pathname;

      if (menus.length > 1) {
        menus = menus.sort(function (a, b) {
          if (a.sort < b.sort) return -1;
          if (a.sort > b.sort) return 1;
          return 0;
        });
      }
      return _react2.default.createElement(
        'ul',
        null,
        menus.map(function (item, index) {
          if (item.isEmpty) {
            return null;
          }
          if (item.children && item.children.length < 1) return null;
          if (item.props && item.props.visible === true) return null;
          if (/^README(.*)md$/.test(item.name)) return null;
          return _react2.default.createElement(
            'li',
            { key: index },
            _react2.default.createElement(
              'div',
              { className: (0, _classnames2.default)({ active: pathname === item.routePath }) },
              item && item.props && (item.props.redirect || item.props.isEmpty) ? _react2.default.createElement(
                'div',
                null,
                item.mdconf && item.mdconf.title || ''
              ) : _react2.default.createElement(
                _reactRouterDom.Link,
                { to: item.routePath, replace: pathname === item.routePath },
                item && item.mdconf.title ? item.mdconf.title : item.name
              )
            ),
            item.children && item.children.length > 0 && _this2.renderSubMenuItem(item.children)
          );
        })
      );
    }
  }, {
    key: 'renderSubMenu',
    value: function renderSubMenu(menus) {
      var _props = this.props,
          pathname = _props.location.pathname,
          routeData = _props.routeData;

      var article = getCurrentArticle(routeData, pathname);
      menus = menus.filter(function (item) {
        return item.article === article;
      });
      if (menus.length < 1) return null;
      var menusObject = menus[0] && menus[0].children ? menus[0].children : [];
      return this.renderSubMenuItem(menusObject);
    }
  }, {
    key: 'isCurentChildren',
    value: function isCurentChildren() {
      var _props2 = this.props,
          pathname = _props2.location.pathname,
          menuSource = _props2.menuSource,
          routeData = _props2.routeData;

      var getRoute = routeData.filter(function (item) {
        return pathname === item.path;
      });
      var article = getRoute.length > 0 ? getRoute[0].article : null;
      var childs = menuSource.filter(function (item) {
        return article === item.article && item.children && item.children.length > 1;
      });
      return childs.length > 0;
    }
  }, {
    key: 'render',
    value: function render() {
      var _classNames;

      var _props3 = this.props,
          menuSource = _props3.menuSource,
          routeData = _props3.routeData,
          indexProps = _props3.indexProps;

      var isChild = this.isCurentChildren();
      return _react2.default.createElement(
        'div',
        { className: _BasicLayout2.default.wapper },
        _react2.default.createElement(_Header2.default, { logo: _rdocLogo2.default, href: '/', location: this.props.location, indexProps: indexProps, menuSource: menuSource }),
        _react2.default.createElement(
          'div',
          { className: _BasicLayout2.default.wapperContent },
          isChild && _react2.default.createElement(
            'div',
            { className: _BasicLayout2.default.menuWapper },
            ' ',
            this.renderSubMenu(menuSource),
            ' '
          ),
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)('content', (_classNames = {}, (0, _defineProperty3.default)(_classNames, '' + _BasicLayout2.default.content, isChild), (0, _defineProperty3.default)(_classNames, '' + _BasicLayout2.default.contentNoMenu, !isChild), _classNames))
            },
            _react2.default.createElement(
              _reactRouterDom.Switch,
              null,
              routeData.map(function (item) {
                // 重定向跳转
                if (item && item.mdconf && item.mdconf.redirect) {
                  var redirectPath = (item.path || '') + '/' + item.mdconf.redirect;
                  redirectPath = redirectPath.replace(/^\/\//, '/');
                  return _react2.default.createElement(_reactRouterDom.Route, { key: item.path, exact: true, path: item.path, render: function render() {
                      return _react2.default.createElement(_reactRouterDom.Redirect, { to: redirectPath });
                    } });
                }
                return _react2.default.createElement(_reactRouterDom.Route, { key: item.path,
                  exact: true,
                  path: item.path,
                  render: function render() {
                    var Comp = item.component;
                    return _react2.default.createElement(Comp, item);
                  }
                });
              }),
              _react2.default.createElement(_reactRouterDom.Redirect, { to: '/404' })
            )
          ),
          _react2.default.createElement(_Footer2.default, null)
        )
      );
    }
  }]);
  return BasicLayout;
}(_react.PureComponent);

exports.default = BasicLayout;