'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMarkdown = require('react-markdown');

var _reactMarkdown2 = _interopRequireDefault(_reactMarkdown);

var _highlight = require('highlight.js');

var _highlight2 = _interopRequireDefault(_highlight);

var _index = require('./style/index.less');

var _index2 = _interopRequireDefault(_index);

var _Canvas = require('./Canvas');

var _Canvas2 = _interopRequireDefault(_Canvas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_highlight2.default.configure({
  tabReplace: '  ', // 2 spaces
  classPrefix: '' // don't append class prefix
});

var formatPath = function formatPath(path) {
  return path.replace(/^(\/|\\)/, '').replace(/\.md$/, '').replace(/\\/g, '/').split('/').join('___');
};

var Markdown = function (_React$Component) {
  (0, _inherits3.default)(Markdown, _React$Component);

  function Markdown(props) {
    (0, _classCallCheck3.default)(this, Markdown);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Markdown.__proto__ || (0, _getPrototypeOf2.default)(Markdown)).call(this, props));

    _this.state = {
      markdownStr: 'loading ... '
    };
    return _this;
  }

  (0, _createClass3.default)(Markdown, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.renderMarkdown();
    }
  }, {
    key: 'renderMarkdown',
    value: function renderMarkdown() {
      var _this2 = this;

      var _props$props = this.props.props,
          type = _props$props.type,
          relative = _props$props.relative;

      var relativeMd = relative;
      if (!relativeMd) return null;
      var filename = formatPath(relativeMd);
      if (type === 'directory') {
        filename = formatPath(relativeMd);
      }
      import('__project_root__/.cache/md/' + filename + '.md').then(function (data) {
        _this2.setState({
          markdownStr: data.default || data
        }, function () {
          var code = _reactDom2.default.findDOMNode(_this2);
          code = code.getElementsByTagName('code');
          for (var i = 0; i < code.length; i += 1) {
            if (code[i].parentNode && code[i].parentNode.tagName === 'PRE') {
              _highlight2.default.highlightBlock(code[i]);
            }
          }
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props$mdconf = this.props.mdconf,
          title = _props$mdconf.title,
          layout = _props$mdconf.layout;

      return _react2.default.createElement(
        'div',
        { className: _index2.default.markdownWapper },
        title && layout !== 'IndexLayout' && _react2.default.createElement(
          'h1',
          { id: title, className: _index2.default.pageTitle },
          title
        ),
        _react2.default.createElement(_reactMarkdown2.default, {
          className: (0, _classnames2.default)('markdown', _index2.default.markdown),
          source: this.state.markdownStr,
          escapeHtml: false,
          renderers: {
            code: _Canvas2.default
          },
          allowNode: function allowNode(node, index, parent) {
            if (node.type === 'html') {}
            // if (/<!--([^]+?)-->/.test(node.value)) return false;
            // const scriptValue = node.value.match(/<script.*?>(.*?)<\/script>/ig);
            // node.value.replace(/<script.*?>(.*?)<\/script>/, (te) => {
            //   console.log('te:', te);
            // });

            // 判断 上一个节点是否为 <!--DemoStart -->
            if (node.type === 'code' && parent.children && parent.children.length > 0 && parent.children[index - 1]) {
              var parentNode = parent.children[index - 1];
              if (parentNode.type === 'html' && /<!--\s?DemoStart\s?-->/.test(parentNode.value)) {
                node.value = '__dome__' + node.value;
              }
            }
            return node;
          }
        })
      );
    }
  }]);
  return Markdown;
}(_react2.default.Component);

exports.default = Markdown;